<?php

error_reporting(0);

# connect to LDAP server

$ldapConn = ldap_connect($ldapServer);

//ldap_set_option($ldapConn, LDAP_OPT_PROTOCOL_VERSION, 3);

if (! $ldapConn)
{
  echo "<br><h4><FONT color=#FF3333>Η αλλαγή κωδικού απέτυχε (error message: unable to connect to LDAP server). Παρακαλούμε ξαναπροσπαθείστε αργότερα. Αν το πρόβλημα επιμένει, επικοινωνείστε με το Κ.Δ.Δ., πτερ. Αντωνιάδου - 4ος όροφος, 210 8203900, <a href=\"mailto:noc@aueb.gr\">noc@aueb.gr</a></FONT></h4>";
  return;
}

// check whether the user should use myPassword to change her password

$binddn = "uid=roservice,ou=services,dc=aueb,dc=gr";
$ldapbind = ldap_bind($ldapConn,$binddn,$roservicePassword);

$searchResult=ldap_search($ldapConn,"ou=People,dc=aueb,dc=gr","(&(schGrAcPersonID=*)(uid=$username))");
$Res = ldap_get_entries($ldapConn, $searchResult);

if ($Res["count"] > 0) {  // the user is registered in URegister, so, she must use myPassword to change her password
  echo "<P><font color=\"red\"><center><h2>Παρακαλούμε χρησιμοποιείστε το <a href=$mypasswordURL>$mypasswordURL</a> για την αλλαγή του κωδικού σας.</center></h2></font></p>";
  echo "<P><center><h3>Please use <a href=$mypasswordURL>$mypasswordURL</a> to change your password.</center></h2></p>";
  ldap_unbind($ldapConn);
  return;
}

//include "../admin/extractpostvariables.phtml";

# do a number of checkings on the data coming from the password-change form

if ($username=="" || $oldpassword=="" || $newpassword1=="")  {
  echo "<br><h4><FONT color=#FF3333>Συμπληρώστε όλα τα πεδία της φόρμας (Please fill in all the fields)</FONT></h4>"; 
  return;
}

if ($newpassword1<>$newpassword2) {
    echo "<br><h4><FONT color=#FF3333>Οι νέοι κωδικοί διαφέρουν (The new passwords are different)</FONT></h4>";
    return;
}

if ($newpassword1==$oldpassword) {
    echo "<br><h4><FONT color=#FF3333>Ο παλιός και ο νέος κωδικός είναι ίδιοι (The new and the old password are the same)</FONT></h4>";
    return;
}

if (strlen($newpassword1) < $passwordlength) {
  echo "<br><h4><FONT color=#FF3333>Ο κωδικός πρέπει να αποτελείται από τουλάχιστον 6 χαρακτήρες (The new password must be at least 6 characters long)</FONT></h4>";
  return;
}

if ($newpassword1==$username) {
  echo "<br><h4><FONT color=#FF3333>Δεν μπορείται να έχετε ίδιο username και password (You can't have the same username and password)</FONT></h4>";
  return;
}

if ($newpassword1=="123" || $newpassword1=="1234" || $newpassword1=="12345" || $newpassword1=="123456" || $newpassword1=="1234567" || $newpassword1=="12345678" || $newpassword1=="123456789" || $newpassword1=="1234567890") {
  echo "<br><h4><FONT color=#FF3333>Μην χρησιμοποιείτε τις ακολουθίες 123456, 1234567, κτλ., σαν password (Don't use 123456, 1234567, etc. as a password)</FONT></h4>";
  return;
}

if ($newpassword1=="qwerty") {
  echo "<br><h4><FONT color=#FF3333>Μην χρησιμοποιείτε το \"qwerty\" σαν password (Don't use \"qwerty\" as a password)</FONT></h4>";
  return;
}

$arr1 = array('|','\'','\\','#','$','(',')','=','{','}',':',';','<','>','"',',',' ');

for ($i=0; $i<=strlen($newpassword1)-1; $i++) {
  if (in_array($newpassword1[$i], $arr1)) {
    echo "<br><h4><FONT color=#FF3333>Δεν μπορείτε να χρησιμοποιήσετε τους χαρακτήρες #$()={}:;\|\"',<> και <font size=-1>[KENO]</font></FONT></h4>";
    return;
  }
  if (ord($newpassword1[$i]) > 179) {
    echo "<br><h4><FONT color=#FF3333>Δεν μπορείτε να χρησιμοποιήσετε Ελληνικούς χαρακτήρες</FONT></h4>";
    return;
  }
}

for ($i=1; $i<=strlen($newpassword1)-1; $i++) {
  if ($newpassword1[$i]!=$newpassword1[$i-1]) {
    $differ++;
  }
}
if (! $differ) {
    echo "<br><h4><FONT color=#FF3333>Ο κωδικός δεν μπορεί να περιέχει μόνο τον ίδιο χαρακτήρα (The password can't consist by the same single character)</FONT></h4>";
    return;
}

/*

# create SSHA1 password

$arr = array(0,1,2,3,4,5,6,7,8,9,q,w,e,r,t,y,u,i,o,p,a,s,d,f,g,h,j,k,l,z,x,c,v,b,n,m,Q,W,E,R,T,Y,U,I,O,P,A,S,D,F,G,H,J,K,L,Z,X,C,V,B,N,M);
$num1=rand(0,61);
$ch1=$arr[$num1];
$num2=rand(0,61);
$ch2=$arr[$num2];
$salt=$ch1;
$salt.=$ch2;

$newpasswordCrypt=crypt($newpassword1, $salt);

  mt_srand((double)microtime()*1000000);
  $salt = pack("CCCC", mt_rand(), mt_rand(), mt_rand(), mt_rand());
  $hash = "{SSHA}" . base64_encode(pack("H*", sha1($newpassword1 . $salt)) . $salt);

$entry["userPassword"] = $hash;

*/

$entry["userPassword"] = $newpassword1;

$binddn = "uid=$username,ou=People,dc=aueb,dc=gr";
$ldapbind = ldap_bind($ldapConn,$binddn,$oldpassword);

if (! $ldapbind) {
  echo "<br><h4><FONT color=#FF3333>Ο κωδικός που δώσατε είναι λάθος (The password is wrong)</FONT></h4>";
  ldap_unbind($ldapConn);
  return;
  }

$ldapmod=ldap_modify($ldapConn, $binddn, $entry);

if ( $ldapmod) {

  echo "<br><h4><FONT COLOR=blue>Η αλλαγή κωδικού έγινε επιτυχώς (The password changed successfully)</FONT></h4>"; 
}
else {
   echo "<br><h4><FONT color=#FF3333>$problemMessage</FONT></h4>";
}

ldap_unbind($ldapConn);

?> 

